/*
   How to de-anonymize an anonymous inner class.
*/

public class Threads_11_experiment_3
{
   public static void main(String[] args)
   {
      Thread t = new Thread(){
         public int x = 1;  // Create "input" values for this thread.
         public int y = 2;
         public void run()
         {
            System.out.println("x1 = " + x + ", y1 = " + y
                             + " from thread " + this.getId() + ".\n");
            x = x + y; // Create an "output" value for this thread.
         }};

      // NOTE: Compile this program, then uncomment one of the
      // next two lines of code, then recompile this program,
      // then run this program.
      //((Threads_11_experiment_3$1)t).x = 10;
      //((Threads_11_experiment_3$1)t).y = 20;

      t.start();

      try
      {
         t.join();
      }
      catch (InterruptedException e){e.getMessage();}

      // Get the thread's "output" value.
      //System.out.println( ((Threads_11_experiment_3$1)t).x );

      System.out.printf("\nAll done (tid = %d).\n", Thread.currentThread().getId());
      return;
   }
}
