/*
   Compare this with 1-thread-vs-function.c
*/

public class Thread_vs_function_1_ver2
{
   public static void main(String[] args)
   {
      final Thread t1 = new Thread1();
      final Thread t2 = new Thread2();

      t1.run();  // Call the run() method in f1.
      t2.run();  // Call the run() method in f2.

      System.out.println("All done (thread id " + Thread.currentThread().getId() + ").");
      return;
   }
}


class Thread1 extends Thread
{
   @Override
   public void run()
   {
      try
      {
         System.out.print("hello ");
         Thread.sleep(1000);  // throws InterruptedException
         System.out.println("from thread " + this.getId() + "!\n");
      }
      catch (InterruptedException e){e.getMessage();}
   }
}


class Thread2 extends Thread
{
   @Override
   public void run()
   {
      try
      {
         System.out.print("HELLO ");
         Thread.sleep(1000);  // throws InterruptedException
         System.out.println("FROM THREAD " + this.getId() + "!\n");
      }
      catch (InterruptedException e){e.getMessage();}
   }
}
