/*
   Compare this with 5-two-threads-in-two-functions.c
*/

public class Thread_vs_function_5
{
   public static void main(String[] args)
   {
      final Runnable f1 = new Function1();
      final Runnable f2 = new Function2();

      final Thread t1 = new Thread( f1 );
      final Thread t2 = new Thread( f2 );

      t1.start();
      t2.start();

      try
      {
         t1.join();
         t2.join();
      }
      catch (InterruptedException e){e.getMessage();}

      System.out.printf("All done (tid %d).\n", Thread.currentThread().getId());
      return;
   }
}


class Function1 implements Runnable
{
   @Override
   public void run()
   {
      while(true) // Loop forever.
      {
         System.out.print("a");
      }
   }
}


class Function2 implements Runnable
{
   @Override
   public void run()
   {
      while(true) // Loop forever.
      {
         System.out.print("b");
      }
   }
}
